/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 2808_CDPSTPO_BUSCA_CUSTO_RECEITA.SQL

Descrio:
   Funo para buscar o custo da receita do produto de acordo com as variaes  do preo da matria prima

Criao:
25/10/2009 - Welbert G. Moitinha
*/


CREATE OR REPLACE PROCEDURE BUSCA_CUSTO_RECEITA(P_IDOPCAO IN VARCHAR2,
                                                P_CDFILIAL IN VARCHAR2,
                                                P_NRTIPOCUSTO  IN NUMBER,
                                                P_SEQTRABPROCF OUT VARCHAR2)
IS
   V_CUSTOATUAL      FLOAT;
   V_VRHISCUSTOPROD  HISTCUSTOPROD.VRHISCUSTOPROD%TYPE;
   V_VRHISPRECOPROD  HISTCUSTOPROD.VRHISPRECOPROD%TYPE;
   V_VRHISTORICO     FLOAT;
   V_VRPERCDIFECUS   FLOAT;
   V_VRCALCCUSTO     FLOAT;
   V_VRPERDIFCUSPREC PARAMPEDIDO.VRPERDIFCUSPREC%TYPE;
   V_IDTPVARATUPRECO PARAMPEDIDO.IDTPVARATUPRECO%TYPE;
   V_STNUMERO        NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_VRDIVISOR       FLOAT;
BEGIN

   V_VRPERCDIFECUS := 0;
   V_CUSTOATUAL :=0;

   BEGIN
      SELECT NVL(VRPERDIFCUSPREC,0), IDTPVARATUPRECO
        INTO V_VRPERDIFCUSPREC, V_IDTPVARATUPRECO
        FROM PARAMPEDIDO
        WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRPERDIFCUSPREC := 0;
         V_IDTPVARATUPRECO := 'P';
   END;


/* BUSCA SEQUENCIAL DA TABELE DE TRABALHO */
    NOVO_CODIGO_SC('TRABDIFCUSTPROD'||P_CDFILIAL, V_STNUMERO, 1);
    V_STNUMERO  :=  SUBSTR( V_STNUMERO,11,10);


/* BUSCA PRODUTOS ACABADOS */
   FOR C_PRODACAB IN (SELECT
                         CDPRODUTO,
                         CDPROCFABRIC,
                         DTVALPROFABR
                      FROM PROCFABRICA
                      WHERE
                         CDFILIAL = P_CDFILIAL AND
                         IDPROFABPADR = 'S')LOOP

      IF P_IDOPCAO = 'I' THEN
         V_CUSTOATUAL := 0;
         V_VRCALCCUSTO := 0;

         FOR C_INSUMOS IN (SELECT NVL(IDSEMIACETAP,'N')AS IDSEMIACETAP, CDPRODINSUMO
                             FROM   INSUMETAPA
                            WHERE
                                 CDFILIAL  =  P_CDFILIAL AND
                                 CDPRODUTO =  C_PRODACAB.CDPRODUTO AND
                                 CDPROCFABRIC = C_PRODACAB.CDPROCFABRIC ) LOOP

            V_CUSTOATUAL := ROUND(CUSTO_PRODUTO( P_CDFILIAL, C_INSUMOS.CDPRODINSUMO, P_NRTIPOCUSTO, SYSDATE, SYSDATE),2)+ V_CUSTOATUAL;
         END LOOP;

         /* BUSCA O CUSTO ANTERIOR  */
         BEGIN
            SELECT NVL(VRHISCUSTOPROD,1), NVL(VRHISPRECOPROD,1)
              INTO V_VRHISCUSTOPROD, V_VRHISPRECOPROD
              FROM HISTCUSTOPROD
             WHERE
               CDFILIALHIST = P_CDFILIAL AND
               CDPRODUTOHIST = C_PRODACAB.CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRHISCUSTOPROD := 0;
               V_VRHISPRECOPROD := 0;
         END;
         
         IF V_CUSTOATUAL > 0 THEN
            IF (V_IDTPVARATUPRECO = 'P') THEN
               V_VRHISTORICO := V_VRHISPRECOPROD;
               V_VRDIVISOR := V_VRHISPRECOPROD;
               IF ((V_VRHISPRECOPROD = 0) OR (V_VRHISPRECOPROD IS NULL)) THEN
                  V_VRDIVISOR := 1;
               END IF;
         
               /* TESTA A DIFERENA*/
               V_VRCALCCUSTO :=  ABS( NVL(V_VRHISPRECOPROD,0) - V_CUSTOATUAL);
            ELSE
               V_VRHISTORICO := V_VRHISCUSTOPROD;
               V_VRDIVISOR := V_VRHISCUSTOPROD;
               IF ((V_VRHISCUSTOPROD = 0) OR (V_VRHISCUSTOPROD IS NULL)) THEN
                  V_VRDIVISOR := 1;
               END IF;
                        
               /* TESTA A DIFERENA*/
               V_VRCALCCUSTO :=  ABS( NVL(V_VRHISCUSTOPROD,0) - V_CUSTOATUAL);
            END IF;

            IF(V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) >= (V_VRPERDIFCUSPREC/100) THEN
               INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                    VALUES( V_STNUMERO, P_CDFILIAL, C_PRODACAB.CDPRODUTO, V_VRHISTORICO, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)));
            END IF;
         END IF;

      ELSE
         V_CUSTOATUAL := 0;
         V_VRCALCCUSTO := 0;

         /* BUSCA O CUSTO ANTERIOR */
         BEGIN
            SELECT NVL(VRHISCUSTOPROD,1), NVL(VRHISPRECOPROD,1)
              INTO V_VRHISCUSTOPROD, V_VRHISPRECOPROD
              FROM HISTCUSTOPROD
             WHERE
               CDFILIALHIST = P_CDFILIAL AND
               CDPRODUTOHIST = C_PRODACAB.CDPRODUTO;

         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRHISCUSTOPROD := 0;
               V_VRHISPRECOPROD := 0;
         END;
         
         V_CUSTOATUAL := ROUND(CUSTO_PRODUTO( P_CDFILIAL, C_PRODACAB.CDPRODUTO, P_NRTIPOCUSTO, SYSDATE, SYSDATE),2);
         
         IF V_CUSTOATUAL > 0 THEN
            IF (V_IDTPVARATUPRECO = 'P') THEN
               V_VRHISTORICO := V_VRHISPRECOPROD;
               V_VRDIVISOR := V_VRHISPRECOPROD;
               IF ((V_VRHISPRECOPROD = 0) OR (V_VRHISPRECOPROD IS NULL)) THEN
                  V_VRDIVISOR := 1;
               END IF;
         
               /* TESTA A DIFERENA*/
               V_VRCALCCUSTO :=  ABS( NVL(V_VRHISPRECOPROD,0) - V_CUSTOATUAL);
            ELSE
               V_VRHISTORICO := V_VRHISCUSTOPROD;
               V_VRDIVISOR := V_VRHISCUSTOPROD;
               IF ((V_VRHISCUSTOPROD = 0) OR (V_VRHISCUSTOPROD IS NULL)) THEN
                  V_VRDIVISOR := 1;
               END IF;
                        
               /* TESTA A DIFERENA*/
               V_VRCALCCUSTO :=  ABS( NVL(V_VRHISCUSTOPROD,0) - V_CUSTOATUAL);
            END IF;

            /* TESTA A DIFERENA*/
            IF NVL(V_VRHISTORICO,0)> 0 THEN
               IF(V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) >= (V_VRPERDIFCUSPREC/100) THEN
                  INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                        VALUES( V_STNUMERO, P_CDFILIAL, C_PRODACAB.CDPRODUTO, V_VRHISTORICO, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)) );
               END IF;
            ELSE
               INSERT INTO TRABDIFCUSTPROD( NRSEQDIFCUST, CDFILIALTRAB, CDPRODUTOTRAB, VRCUSTANTPROD, VRCUSTATUPROD, VRPERDIFCUSTPRO)
                                        VALUES( V_STNUMERO, P_CDFILIAL, C_PRODACAB.CDPRODUTO, V_VRHISTORICO, V_CUSTOATUAL, (V_VRCALCCUSTO * 100 / NVL(V_VRDIVISOR,1)));
            END IF;
         END IF;
      END IF;
   END LOOP;
   P_SEQTRABPROCF := V_STNUMERO;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_CUSTO_RECEITA','6.19.000'); END;
/